package com.sf.service.gateway.domain.dto;

import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;

/**
 * 功能描述:
 *  更新数据状态
 * @author a_kun
 * @date 2024/4/23 10:38
 */
@Data
public class UpdateDataStatusDTO {

    @NotNull(message = "至少需要一条数据ID")
    @Size(min = 1,message = "至少需要一条数据ID")
    private List<Long> ids;

    /**
     * 状态（0停用 1启用）
     */
    @NotBlank(message = "状态标识不能为空")
    private String status;

}
